#include <dos.h>
#include <stdio.h>
#include <stdlib.h>

#define TRUE      1
#define FALSE     0
#define timetick	*((unsigned far *)0x0040006c)

#define MB_LEFT       	1
#define MB_RIGHT      	2
#define MB_MID        	3
#define MB_PRESS        1
#define MB_RELEASE	0

float dblclktime=0.3;
int dblclked=FALSE;
int clicked=FALSE;
int m_drag=FALSE;
int mlb_pres=FALSE;
int mrb_pres=FALSE;
int mmb_pres=FALSE;

unsigned atclktime=0;
int lastpushstate=FALSE;
int lastmx=0;
int lastmy=0;

int mp_gx=0;
int mp_gy=0;
int mp_x=0;
int mp_y=0;
int mp_bs=0;
int mp_bcnt=0;

int mr_gx=0;
int mr_gy=0;
int mr_x=0;
int mr_y=0;
int mr_bs=0;
int mr_bcnt=0;

int MouseState(char *num)
{
  asm  xor       ax,    ax
  asm  int       33h
  *num=_BX;
  return(((int)_AX == -1) ? TRUE:FALSE);
}

void MouseCursor(int TF)
{
	_AX=(TF) ? 1:2;
	asm     int     33h
}

int GetMouseButton(void)
{
	asm  mov     ax,     3
	asm  int     33h
	return(_BX);
}

void GetCoordinate(int  *Horizon, int *Vertical)
{
	asm     mov     ax,     3
	asm     int     33h
	*Horizon        =_CX;
	*Vertical       =_DX;
}

void SetCoordinate(int  Horizon, int Vertical)
{
		asm     mov     ax,     4
		asm     mov     cx,     Horizon
	asm     mov     dx,     Vertical
	asm     int     33h
}

void SetHorizonRange(int Left, int Right)
{
	asm     mov     ax,     7
		asm     mov     cx,     Left
	asm     mov     dx,     Right
		asm     int     33h
}

void SetVerticalRange(int Top, int Bottom)
{
        asm     mov     ax,     8
        asm     mov     bx,     Top
        asm     mov     cx,     Bottom
	asm     int     33h
}

void SetMouseCursor(int TF)
{
	asm     mov     ax,     10
	asm     mov     bx,     TF
	asm     int     33h
}

void SetHiddenRange(int Top, int Left, int Bottom, int Right)
{
	asm     mov     ax,     16
	asm     mov     bx,     Left
	asm     mov     cx,     Top
	asm     mov     dx,     Right
	asm     mov     es,     Bottom
	asm     int     33h
}

void mbinfo(int but)
{
  union REGS m;

  /* press */
  m.x.ax=5;
  m.x.bx=but-1;
  int86(0x33, &m, &m);

  mp_gx=m.x.cx;
  mp_gy=m.x.dx;
  mp_x=mp_gx/8;
  mp_y=mp_gy/8;
  mp_bs=m.x.ax;
  mp_bcnt=m.x.bx;

  /* release */
  m.x.ax=6;
  m.x.bx=but-1;
  int86(0x33, &m, &m);

  mr_gx=m.x.cx;
  mr_gy=m.x.dx;
  mr_x=mr_gx/8;
  mr_y=mr_gy/8;
  mr_bs=m.x.ax;
  mr_bcnt=m.x.bx;
}

void mouseprocess(void)
{
    int curx=0, cury=0;

    clicked=FALSE;

	if (dblclked) {
      dblclked=FALSE;
      atclktime=0;
    }

    mbinfo(MB_LEFT);

    if (mp_bcnt>0) lastpushstate=TRUE;
    mlb_pres=(mp_bs==MB_LEFT) ? (TRUE):(FALSE);
    mrb_pres=(mp_bs==MB_RIGHT) ? (TRUE):(FALSE);
    mmb_pres=(mp_bs==MB_MID) ? (TRUE):(FALSE);

	GetCoordinate(&curx, &cury);  /* returns graphical coordinate */
	curx/=8;
	cury/=8;

	if (((mp_x != curx) || (mp_y != cury)) && (mlb_pres)) m_drag=TRUE;
	else m_drag=FALSE;

	if (mr_bcnt>0)     /* if released */
	  if (lastpushstate) {
	if ((abs(atclktime-timetick) < (int)(18.2*dblclktime+0.5)) ||
		(mr_bcnt>=2 || mp_bcnt>=2)) dblclked=TRUE;

	lastpushstate=FALSE;
	clicked=TRUE;
	atclktime=timetick;
	  }

}

